/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* Ce logiciel est du domaine public. Vous avez la permission   *
* d'utiliser, de copier et de modifier ce logiciel.            *
****************************************************************
* Ne me contactez pas SVP pour des informations, bugs,         *
* commentaires, problemes, contributions, offres d'emploi.     *
* Si vous aimez ce logiciel, envoyez une carte postale a       *
* l'adresse suivante :                                         *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA (Moldavie)                                           *
****************************************************************
* L'auteur n'est pas responsable pour les dommages occasionnes *
* par l'utilisation de ce logiciel ou de ses derives.          *
\**************************************************************/

import java.applet.Applet;
import java.awt.Color;

public class VasAfficheEtat extends Applet implements Runnable {
  String msg;
  int attente=60;
  int cour=0;
  int longMsg;
  Thread affMsg;

  public String getAppletInfo() {
    return (new String("VasAfficheEtat v1.0, 31 mars 1998, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  public void init() {
    //attente avant de rafraichir
    try {
      attente=Integer.parseInt(getParameter("rafraichir"));
      if(attente<10) attente=60;
    }
    catch(Exception e) {attente=60;}

    //pour mettre la couleur de fond, car la taille de l'applet par defaut est de 5x5
    try{
      //la couleur du fond de l'applet (le meilleur c'est d'avoir le meme que celui da la page HTML)
      //par example #000000 pour le noir ou #FFFFFF pour le blanc
      //on prends les parametres depuis la page HTML
      String couleur=getParameter("couleur");
      if(couleur==null) couleur=new String("#B4B88C");
      setBackground(new Color(Integer.parseInt(couleur.substring(1, 3), 16), Integer.parseInt(couleur.substring(3, 5), 16),Integer.parseInt(couleur.substring(5, 7), 16)));
    }
    catch(Exception ee) {;}

    //le message a afficher
    String byDefault=new String("   (C) VasAfficheEtat");
    msg=getParameter("msg");
    msg=new String(msg+byDefault);
    longMsg=msg.length();
    StringBuffer tempo=new StringBuffer(msg+msg);
    for(int i=0; i<longMsg; i++) tempo.setCharAt(i, ' ');
    msg=tempo.toString();
    longMsg=msg.length();
    affMsg=new Thread(this);
    affMsg.start();
  }

  public void start() {
    if(affMsg==null) {
      affMsg=new Thread(this);
      affMsg.start();
    }
  }

  public void stop() {
    if(affMsg!=null) {
      affMsg.stop();
      affMsg=null;
    }
  }

  public void run() {
    while(true) {
      try {
        showStatus(msg.substring (cour>0 ? cour : -cour));
        if(++cour==longMsg-1) cour=-cour;
        Thread.sleep((long)attente);
      }
      catch(InterruptedException e) {stop();}
    }
  }
}//end class VasAfficheEtat
